require(['angular', 'components/shared/index'], function (angular) {
    var enhancedEnrollmentSummary = angular.module('enhancedEnrollmentSummary', ['powerSchoolModule']);
    enhancedEnrollmentSummary.controller('enhancedEnrollmentSummaryController', function ($scope, $http, $timeout, $attrs) {

        let vm = this;    
        vm.studsInSet=$attrs.studsindset;
        vm.isDistrict = $attrs.district;
        vm.schoolname = $attrs.schoolname;
        vm.curschoolid = $attrs.curschoolid;
        vm.schoolGroup=false;
        vm.studentsFound = true;
        vm.curSelection=[];
        vm.schoolSelectionParam = "";
        vm.hideCharting = true;
        vm.chkSchool={};
        vm.chkGender={};

        vm.selectedDate = new Date(Date.now()).toLocaleString().split(',')[0];

        vm.config = {
            status:'loading...'
        };

        vm.currentViewId = 1;
        vm.studentSelection = "1";
        
        vm.destroyChart=function(){
            Chart.getChart("myChart")===undefined ? false : Chart.getChart("myChart").destroy();
        }
        //Load Students
        vm.load_students = function(byView){
            vm.hideCharting = true;
            Chart.getChart("myChart")===undefined ? false : Chart.getChart("myChart").destroy();
            vm.config.status = 'loading...';
            vm.byView = byView;
            vm.currentView = vm.view.filter((e)=>e.id==vm.currentViewId)[0];
            vm.selectedDate = vm.selectedDate.toLocaleString().split(',')[0];
            let params = {
                field: vm.currentView.field, 
                field_name: vm.currentView.field_name, 
                tblJoiner: vm.currentView.tblJoiner,
                schoolSelectionParam: vm.schoolSelectionParam,
                selDate: vm.selectedDate.toString(),
                currentSelection: vm.studentSelection=="2"?"1":"0"
            }
            $http({
                "url": '/admin/mbaEnhancedEnrollmentSummary/getStudents.txt',
                "method": 'POST',
                "data":  $j.param(params), 
                "headers": {"Content-Type": "application/x-www-form-urlencoded"}
            })
            .then(function(response){
                try {
                    if(!Object.keys(response.data).length) vm.studentsFound=false;
                    else vm.studentsFound = true; 
                    let res = JSON.parse(JSON.stringify(response.data).replace(/\:null/gi, "\:\"Undefined\""));
                    vm.students = res;                    
                    vm.grade_levels = [...new Set(res.map(student => student.grade_level))].sort((a,b)=>a-b);
                    vm.columns = Array.from([...new Set(res.map(student => student[vm.currentView.field_name]))]);
                    vm.columns = vm.currentView.dataType=='int' ? vm.columns.sort((a,b)=>a-b) : vm.columns.sort((a,b)=>a.localeCompare(b));
                    $timeout(()=>{vm.config.status='complete';},100);
                    vm.createBarChart('Grade Level', undefined, '');
                }
                catch (error) {
                    vm.studentsFound = false;
                    $timeout(()=>{vm.config.status='complete';},100);
                }
            });
        }

        vm.getAllSchools = function() {
                $http({
                    "url": '/admin/mbaEnhancedEnrollmentSummary/getSchoolInformation.txt',
                    "method": 'POST',
                    "data":  '',
                    "headers": {"Content-Type": "application/x-www-form-urlencoded"}
                })
                .then(function(response){
                    response.data.pop();
                    vm.allSchools = response.data;
                    vm.allSchools.sort((a,b)=>a.name.localeCompare(b.name));
                    $timeout(()=>{
                    $j('#schoolSelection').multipleSelect({
                            multiple: true,
                            width: '9em',
                            multipleWidth: 140,
                            dropWidth: 120,
                            placeholder: 'No Exclusions',
                            selectAllText: 'All Schools',
                            allSelected: 'All Schools'
                    });
                },1);

                });

        }

        //Load Views (configuration)
        vm.getAllSchools(); 
        vm.load_view = function(){
            $http({
                "url": '/admin/mbaEnhancedEnrollmentSummary/getView.txt',
                "method": 'POST',
                "data":"",
                "headers": {"Content-Type": "application/x-www-form-urlencoded"}
            })
            .then(function(response){
                let res = angular.copy(response.data);
                vm.view = vm.isDistrict=="true" ? res : res.filter(e => e.districtOnly == "false");
                vm.view = vm.view.filter(e=>!e.disabled);
                vm.currentViewId = vm.view[0].id;
                vm.load_students(vm.view);
            });

        }

        vm.getCount = function(gradeLevel,col,typ){
            try{
                var filtStudents=[];
                switch(typ){
                    case 'col':
                        filtStudents=vm.students.filter((student)=>student[vm.currentView.field_name] == col);
                    break;
                    case 'row':
                        filtStudents=vm.students.filter((student)=>student.grade_level==gradeLevel);
                    break;
                    case 'total':
                        filtStudents=vm.students;
                    break;
                    default:
                        filtStudents=vm.students.filter((student)=>student.grade_level==gradeLevel && student[vm.currentView.field_name] == col);

                }
                return filtStudents.length;
            }
            catch(e){return 0;}
        }

        vm.createBarChart = function (name, value,typ) {
            Chart.getChart("myChart") !==undefined ? Chart.getChart("myChart").destroy() : false;

            let studentFields = [], labels=[], dataSet=[];
            if(typ=='Total'){
                vm.grade_levels.forEach(grade=>{
                    labels.push(grade);
                    if(name=='grade_level'){
                        dataSet.push(vm.students.filter((student)=>student.grade_level == grade).length);
                    }
                    else{
                        dataSet.push(vm.students.filter((student)=>student.grade_level == grade && student[vm.currentView.field_name] == value).length);
                    }
                });
            }
            else{
                let ds = value == undefined ? vm.students : vm.students.filter((student)=>student.grade_level==value);
                vm.columns.forEach(col=>{
                    labels.push(col);
                    dataSet.push(ds.filter((student)=>student[vm.currentView.field_name] == col).length);
                });
            }

            const data = {
                labels: labels,
                datasets: [{
                backgroundColor: [
                    'rgba(255, 99, 132, 0.2)',
                    'rgba(255, 159, 64, 0.2)',
                    'rgba(255, 205, 86, 0.2)',
                    'rgba(75, 192, 192, 0.2)',
                    'rgba(54, 162, 235, 0.2)',
                    'rgba(153, 102, 255, 0.2)',
                    'rgba(201, 203, 207, 0.2)'
                ],
                borderColor: [
                    'rgb(255, 99, 132)',
                    'rgb(255, 159, 64)',
                    'rgb(255, 205, 86)',
                    'rgb(75, 192, 192)',
                    'rgb(54, 162, 235)',
                    'rgb(153, 102, 255)',
                    'rgb(201, 203, 207)'
                ],
                data: dataSet,
                }]
            };

            newOptions = {
                indexAxis: name == "Grade Level" ? 'y' : 'x',
                plugins: {
                    legend: {
                        display: false
                    },
                    title: {
                        display: true,
                        text: name == "Grade Level" ? "Enrollment By " + vm.currentView.name : "Enrollment By Grade"
                    },
                    subtitle: {
                        display: true,
                        text: name == ("Grade Level" && value != undefined) ? "Grade " + value : (name=="Total") ? "All " + vm.currentView.name + " Categories"  :  vm.currentView.name + " " + name.replace('grade_level','')

                    }
                },
                scales: {
                    y: {
                        title: {
                            display: true,
                            text: name == "Grade Level" ? vm.currentView.name : "Number of Students"
                        }
                    },
                    x: {
                        title: {
                            display: true,
                            text: name == "Grade Level" ? "Number of Students" : "Grade Level"
                        }
                    }
                }
            };

            const config = {
                type: 'bar',
                data: data,
                options: newOptions
            };
            let myChart = new Chart(
                document.getElementById('myChart'),
                config
            );
        }

        //Preload student data
        vm.load_view();

        vm.chartCount = 0;

        vm.displayModal = function(colVal, gradeLevel) {
            //reset values
            $j('H2.expanded').trigger('click');
            $j('.selCheck').prop('checked',false);
            let colName = vm.currentView.field_name;
            vm.gradeLevel=gradeLevel;
            vm.currentStudents = [];                    
            if(gradeLevel===undefined){
                if(colVal===undefined || colVal=="Grade Count") vm.currentStudents = vm.students;
                else vm.currentStudents = vm.students.filter((student)=>student[colName]==colVal);
            }
            else{
                if(colVal==="Grade Count") vm.currentStudents = vm.students.filter((student)=>student.grade_level==gradeLevel);
                else vm.currentStudents = vm.students.filter((student)=>student.grade_level==gradeLevel && student[colName]==colVal);
            }
//                vm.currentStudents = (gradeLevel===undefined) ? vm.students : (colVal=='Grade Count') ? vm.students.filter((student)=>student.grade_level==gradeLevel): vm.students.filter((student)=>student.grade_level==gradeLevel && student[colName]==colVal);
            vm.curSchools = Array.from([...new Set(vm.currentStudents.map(student => student.school_name))]).sort((a,b)=>a.localeCompare(b));
            let genderArr = Array.from([...new Set(vm.currentStudents.map(student =>({"student_gender": student.student_gender, "gender": student.gender})))]).sort((a,b)=>a.gender.localeCompare(b.gender));
            vm.curGenders=([...new Map(genderArr.map(v => [JSON.stringify(v), v])).values()]);
            vm.grouping = vm.schoolGroup==true ? 'School' : 'Gender';
            //reset values
            vm.selStudents=[];
            vm.schoolGroup=false;
            vm.chkAll=false;
            vm.selectGroups();
            $timeout(()=>{
                $j('#modalClickDialog').dialog({modal:true,title:'Grade Level: ' + gradeLevel,width:800,resizable:false});
            },0);

        }
        vm.selectGroups=function(){
            if(vm.schoolGroup){
                for (const [key, value] of Object.entries(vm.chkSchool)) {
                    vm.chkSchool[key]=vm.chkAll;
                }
                for (const [key, value] of Object.entries(vm.chkSchool)) {
                    if(vm.curSchools[key]!==undefined) vm.select_students('school_name',key, vm.currentStudents.filter(e=>e.school_name == vm.curSchools[key].school_name));
                }
            }
            if(!vm.schoolGroup){
                for (const [key, value] of Object.entries(vm.chkGender)) {
                    vm.chkGender[key]=vm.chkAll;
                }
                for (const [key, value] of Object.entries(vm.chkGender)) {
                    if(vm.curGenders[key]!==undefined) vm.select_students('gender',key, vm.currentStudents.filter(e=>e.gender == vm.curGenders[key].gender));
                }
            }
        }
        vm.select_students=function(fld, indx, students){
            let add = (fld == 'school_name') ? vm.chkSchool[indx] : vm.chkGender[indx];
            vm.selStudents=(add==true) ? vm.selStudents.concat(students) : vm.selStudents.filter(ar => !students.find(rm => (rm.dcid === ar.dcid) ));
            //check if all checkboxes are selected or not
            //console.log(vm.selStudents);
            let falseCount=0;
            if(vm.schoolGroup){
                for (const [key, value] of Object.entries(vm.chkSchool)) {
                    if(vm.chkSchool[key]==false) falseCount++;
                }
            }
            if(!vm.schoolGroup){
                for (const [key, value] of Object.entries(vm.chkGender)) {
                    if(vm.chkGender[key]==false) falseCount++;
                }
            }
            vm.chkAll = falseCount==0 ? true : false;
        }
        vm.loadCurrentSelection=function(){
            $http({
                    "url": '/admin/mbaEnhancedEnrollmentSummary/getCurrentSelection.txt',
                    "method": 'POST',
                    "data":  '',
                    "headers": {"Content-Type": "application/x-www-form-urlencoded"}
            })
            .then(function(response){
                if(!Object.keys(response.data).length) vm.curSelection=[];
                else vm.curSelection=response.data.split(',');
                vm.curSelection.pop();
                vm.optStudents=[{id:"1",value:"All Students at "+vm.schoolname},{id:"2",value:"Current Selection at "+vm.schoolname+" ("+vm.curSelection.length+")"}];
            });
        };
        vm.makeSelection=function(method){
            //method takes 'append' or 'make'
            loadingDialog();
            if(vm.selStudents.length<1){
                closeLoading();
                psAlert({message:'You have not selected any students to add to the current selection.',title:"No students selected"});
                return false;
            }
            let dcidString = method=='append' ? vm.curSelection.join(',') : '';
            vm.selStudents.forEach(student => {
                dcidString += dcidString=="" ? student.dcid : (',') + student.dcid;
            });
            var stuList = {"ac":"buildsel;table=students;list=" + dcidString};
            var dcidArray = dcidString.split(",");
            const uniqueArray = [...new Set(dcidArray)];
            $http({
                "url":'/admin/home.html',
                "method":"POST",
                "data": $j.param(stuList),   
                "headers": {"Content-Type": "application/x-www-form-urlencoded"}
            })
            .then(function(response){
                vm.loadCurrentSelection();
                psAlert({message:'Current Selection Updated (' + uniqueArray.length + ')',title:"Selection Set"});
            });
        }

        vm.columns = {};

        vm.collapseAll = function(){
            $j('H2.expanded').trigger('click');
        }

        vm.expandAll = function(){
            $j('H2.collapsed').trigger('click');
        }

        vm.changeCurrentSchools = function () {
            //could filter the already loaded dataset here instead of re-fetching; 
            //leave for now
            vm.schoolSelectionParam = vm.schoolSelection.length>0?"'"+Object.values(vm.schoolSelection).join("','")+"'":"";
            vm.load_students();
        }
        vm.handleDisplayGraph = function (firstVal, secondVal, thirdVal) {
            vm.hideCharting = false;
            vm.createBarChart(firstVal, secondVal, thirdVal);
        }
        vm.loadCurrentSelection();
    })
    .filter('groupStudents', function(){
        return function(arr,fld,val){
            return arr.filter(student=>student[fld]==val);
        }
    })
    //Bootstrap the app to the document
    angular.element(function(){
        angular.bootstrap(document, ['enhancedEnrollmentSummary']);
    });

});